DEFINE CLASS wwUserSecurityTests as FxuTestCase OF FxuTestCase.prg


*** SETUP AND CONFIGURATION *** 

************************************************************************
*  Setup
****************************************
***  Function:
***    Assume:
***      Pass:
***    Return:
************************************************************************
FUNCTION Setup()

	*** Make sure libraries are loaded
	DO wconnect
	DO wwUserSecurity
	DO wwEncryption
ENDFUNC
*   Setup

************************************************************************
*  TearDown
****************************************
***  Function:
***    Assume:
***      Pass:
***    Return:
************************************************************************
FUNCTION TearDown()

ENDFUNC
*   TearDown

PROTECTED FUNCTION CreateUserWithPassword

loSecurity = CREATEOBJECT("wwUserSecurity")
loSecurity.cPasswordEncryptionKey = "seekrit"

RETURN loSecurity
ENDFUNC




************************************************************************
*  Fix UserSecurity Table
****************************************
***  Function:
***    Assume:
***      Pass:
***    Return:
************************************************************************
FUNCTION FixUserSecurityTable

loSecurity = THIS.CreateUserWithPassword()
llResult = loSecurity.FixupTable()

ENDFUNC




************************************************************************
*  GetUser
****************************************
***  Function:
***    Assume:
***      Pass:
***    Return:
************************************************************************
FUNCTION GetUser
loSecurity = THIS.CreateUserWithPassword()


llResult = loSecurity.GetUser("test@test.com","test")

THIS.AssertTrue(llResult)

THIS.AssertTrue(!IsNull(loSecurity.oUser) )

THIS.MessageOut(loSecurity.oUser.Username)

ENDFUNC


************************************************************************
*  Authenticate
****************************************
***  Function:
***    Assume:
***      Pass:
***    Return:
************************************************************************
FUNCTION Authenticate 
loSecurity = THIS.CreateUserWithPassword()

llResult = loSecurity.Authenticate("test@test.com","test")
THIS.AssertTrue(llResult,"Matching creds should match")

llResult = loSecurity.Authenticate("test@test.com","")
THIS.AssertTrue(!llResult,"Empty Password should fail.")


ENDFUNC


************************************************************************
*  LoadUser
****************************************
***  Function:
***    Assume:
***      Pass:
***    Return:
************************************************************************
FUNCTION LoadUser()

loSecurity = THIS.CreateUserWithPassword()
loUser = loSecurity.Load("1")

this.AssertTrue(!IsNull(loUser))

ENDFUNC
*   LoadUser

************************************************************************
*  SaveUser
****************************************
***  Function:
***    Assume:
***      Pass:
***    Return:
************************************************************************
FUNCTION SaveUser()

loSecurity = THIS.CreateUserWithPassword()
loSecurity.Load("1")

lcOld = loSecurity.oUser.password

loSecurity.SaveUser()

lcnew = loSecurity.oUser.password
this.MessageOut(lcOld + " New: " +  lcNew)

THIS.AssertTrue( .T. )

ENDFUNC
*   SaveUser


************************************************************************
*  SaveNewUser
****************************************
***  Function:
***    Assume:
***      Pass:
***    Return:
************************************************************************
FUNCTION SaveNewUser()

loSecurity = THIS.CreateUserWithPassword()

THIS.AssertTrue( loSecurity.NewUser(),loSecurity.cErrorMsg)

loUser = loSecurity.oUser
loUser.Username = "test2@west-wind.com"
loUser.Password = "test2"
loUser.FullName = "Test2 User"

lcOld = loSecurity.oUser.password

llResult = loSecurity.SaveUser()

this.AssertTrue(llResult,loSecurity.cErrorMsg)

lcnew = loSecurity.oUser.password
this.MessageOut(lcOld + " New: " +  lcNew)

loSecurity.DeleteUser(loSecurity.oUser.Pk)

THIS.AssertTrue( .T. )

ENDFUNC
*   SaveUser


************************************************************************
*  DeleteUser
****************************************
***  Function:
***    Assume:
***      Pass:
***    Return:
************************************************************************
FUNCTION DeleteUser()

loSecurity = THIS.CreateUserWithPassword()
loSecurity.DeleteUser("1")

LOCATE FOR Pk == "1"
llResult = !FOUND()

THIS.AssertTrue(llResult,"Not deleted")
RECALL FOR Pk == "1"

ENDFUNC
*   SaveUser




ENDDEFINE
